/*
 * Copyright 1993-2007 NVIDIA Corporation.  All rights reserved.
 *
 * NVIDIA Corporation and its licensors retain all intellectual property and 
 * proprietary rights in and to this software and related documentation and 
 * any modifications thereto.  Any use, reproduction, disclosure, or distribution 
 * of this software and related documentation without an express license 
 * agreement from NVIDIA Corporation is strictly prohibited.
 * 
 */



#ifndef SORTINGNETWORKS_COMMON_CUH
#define SORTINGNETWORKS_COMMON_CUH



#define    UMUL(a, b) __umul24((a), (b))
#define UMAD(a, b, c) ( UMUL((a), (b)) + (c) )



#define SHARED_SIZE_LIMIT 1024U



__device__ void Comparator(
    unsigned int& keyA,
    unsigned int& valA,
    unsigned int& keyB,
    unsigned int& valB,
    unsigned int dir
){
    unsigned int t;
    if( (keyA > keyB) == dir ){
        t = keyA; keyA = keyB; keyB = t;
        t = valA; valA = valB; valB = t;
    }
}



#endif
