/*
 * Copyright 1993-2009 NVIDIA Corporation.  All rights reserved.
 *
 * NVIDIA Corporation and its licensors retain all intellectual property and 
 * proprietary rights in and to this software and related documentation and 
 * any modifications thereto.  Any use, reproduction, disclosure, or distribution 
 * of this software and related documentation without an express license 
 * agreement from NVIDIA Corporation is strictly prohibited.
 * 
 */



///////////////////////////////////////////////////////////////////////////////
// Sort result validation routines
////////////////////////////////////////////////////////////////////////////////
//Sorted keys array validation (check for integrity and proper order)
extern "C" unsigned int validateSortedKeys(
    unsigned int *resKey,
    unsigned int *srcKey,
    unsigned int batchSize,
    unsigned int arrayLength,
    unsigned int numValues,
    unsigned int dir
);

//Input key to value translation
extern "C" void generateValuesFromKeys(
    unsigned int *ival,
    unsigned int *ikey,
    unsigned int N
);

//Check output values to match output keys by the same translation function
extern "C" int validateValues(
    unsigned int *oval,
    unsigned int *okey,
    unsigned int N
);



////////////////////////////////////////////////////////////////////////////////
// CUDA sorting networks
////////////////////////////////////////////////////////////////////////////////
//Return 1 if compiled for device emulation
extern "C" int isDeviceEmulation(void);

extern "C" void bitonicSort(
    unsigned int *d_DstKey,
    unsigned int *d_DstVal,
    unsigned int *d_SrcKey,
    unsigned int *d_SrcVal,
    unsigned int batchSize,
    unsigned int arrayLength,
    unsigned int dir
);

extern "C" void oddEvenMergeSort(
    unsigned int *d_DstKey,
    unsigned int *d_DstVal,
    unsigned int *d_SrcKey,
    unsigned int *d_SrcVal,
    unsigned int batchSize,
    unsigned int arrayLength,
    unsigned int dir
);
